package java.util;

import java.security.AccessController;
import jdk.internal.util.xml.BasicXmlPropertiesProvider;
import java.security.PrivilegedAction;
import sun.util.spi.XmlPropertiesProvider;
import java.io.PrintWriter;
import java.io.PrintStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.io.OutputStream;
import java.io.BufferedWriter;
import java.io.InputStream;
import java.io.IOException;
import java.io.Reader;

public class Properties extends Hashtable<Object, Object>
{
    private static final long serialVersionUID = 4112578634029874840L;
    protected Properties defaults;
    private static final char[] hexDigit;
    
    public Properties() {
        this(null);
    }
    
    public Properties(Properties defaults) {
        this.defaults = defaults;
    }
    
    public synchronized Object setProperty(String s, String s2) {
        return this.put(s, s2);
    }
    
    public synchronized void load(Reader reader) throws IOException {
        this.load0(new Properties.LineReader(reader));
    }
    
    public synchronized void load(InputStream inputStream) throws IOException {
        this.load0(new Properties.LineReader(inputStream));
    }
    
    private void load0(Properties.LineReader lineReader) throws IOException {
        char[] array = new char[1024];
        int i;
        while ((i = lineReader.readLine()) >= 0) {
            int j = 0;
            int n = 0;
            boolean n2 = false;
            while (j < i) {
                int n3 = lineReader.lineBuf[j];
                if ((n3 == '=' || n3 == ':') && n2 == 0) {
                    i = j + 1;
                    n = 1;
                    break;
                }
                if ((n3 == ' ' || n3 == '\t' || n3 == '\f') && n2 == 0) {
                    i = j + 1;
                    break;
                }
                n2 = (n3 == '\\' && n2 == 0);
                ++j;
            }
            while (i < i) {
                int n4 = lineReader.lineBuf[i];
                if (n4 != ' ' && n4 != '\t' && n4 != '\f') {
                    if (n == 0 && (n4 == '=' || n4 == ':')) {
                        n = 1;
                    }
                    else {
                        break;
                    }
                }
                ++i;
            }
            this.put(this.loadConvert(lineReader.lineBuf, 0, j, array), this.loadConvert(lineReader.lineBuf, i, i - i, array));
        }
    }
    
    private String loadConvert(char[] array, int i, int n, char[] value) {
        if (value.length < n) {
            int n2 = n * 2;
            if (n2 < 0) {
                n2 = Integer.MAX_VALUE;
            }
            value = new char[n2];
        }
        int count = 0;
        while (i < i + n) {
            int n3 = array[i++];
            if (n3 == '\\') {
                int n4 = array[i++];
                if (n4 == 'u') {
                    int n5 = 0;
                    for (int j = 0; j < 4; ++j) {
                        int n6 = array[i++];
                        switch (n6) {
                            case 48:
                            case 49:
                            case 50:
                            case 51:
                            case 52:
                            case 53:
                            case 54:
                            case 55:
                            case 56:
                            case 57: {
                                n5 = (n5 << 4) + n6 - 48;
                                break;
                            }
                            case 97:
                            case 98:
                            case 99:
                            case 100:
                            case 101:
                            case 102: {
                                n5 = (n5 << 4) + 10 + n6 - 97;
                                break;
                            }
                            case 65:
                            case 66:
                            case 67:
                            case 68:
                            case 69:
                            case 70: {
                                n5 = (n5 << 4) + 10 + n6 - 65;
                                break;
                            }
                            default: {
                                throw new IllegalArgumentException("Malformed \\uxxxx encoding.");
                            }
                        }
                    }
                    value[count++] = (char)n5;
                }
                else {
                    if (n4 == 't') {
                        n4 = '\t';
                    }
                    else if (n4 == 'r') {
                        n4 = '\r';
                    }
                    else if (n4 == 'n') {
                        n4 = '\n';
                    }
                    else if (n4 == 'f') {
                        n4 = '\f';
                    }
                    value[count++] = n4;
                }
            }
            else {
                value[count++] = n3;
            }
        }
        return new String(value, 0, count);
    }
    
    private String saveConvert(String s, boolean b, boolean b2) {
        int length = s.length();
        int capacity = length * 2;
        if (capacity < 0) {
            capacity = Integer.MAX_VALUE;
        }
        StringBuffer o = new StringBuffer(capacity);
        for (int i = 0; i < length; ++i) {
            int char1 = s.charAt(i);
            if (char1 > '=' && char1 < '\u007f') {
                if (char1 == '\\') {
                    o.append('\\');
                    o.append('\\');
                }
                else {
                    o.append((char)char1);
                }
            }
            else {
                switch (char1) {
                    case 32: {
                        if (i == 0 || b) {
                            o.append('\\');
                        }
                        o.append(' ');
                        break;
                    }
                    case 9: {
                        o.append('\\');
                        o.append('t');
                        break;
                    }
                    case 10: {
                        o.append('\\');
                        o.append('n');
                        break;
                    }
                    case 13: {
                        o.append('\\');
                        o.append('r');
                        break;
                    }
                    case 12: {
                        o.append('\\');
                        o.append('f');
                        break;
                    }
                    case 33:
                    case 35:
                    case 58:
                    case 61: {
                        o.append('\\');
                        o.append((char)char1);
                        break;
                    }
                    default: {
                        if (((char1 < ' ' || char1 > '~') & b2)) {
                            o.append('\\');
                            o.append('u');
                            o.append(toHex(char1 >> 12 & 0xF));
                            o.append(toHex(char1 >> 8 & 0xF));
                            o.append(toHex(char1 >> 4 & 0xF));
                            o.append(toHex(char1 & '\u000f'));
                            break;
                        }
                        o.append((char)char1);
                        break;
                    }
                }
            }
        }
        return o.toString();
    }
    
    private static void writeComments(BufferedWriter bufferedWriter, String s) throws IOException {
        bufferedWriter.write("#");
        int length = s.length();
        int i = 0;
        int n = 0;
        char[] value = new char[6];
        value[0] = '\\';
        value[1] = 'u';
        while (i < length) {
            int char1 = s.charAt(i);
            if (char1 > 'ÿ' || char1 == '\n' || char1 == '\r') {
                if (n != i) {
                    bufferedWriter.write(s.substring(n, i));
                }
                if (char1 > 'ÿ') {
                    value[2] = toHex(char1 >> 12 & 0xF);
                    value[3] = toHex(char1 >> 8 & 0xF);
                    value[4] = toHex(char1 >> 4 & 0xF);
                    value[5] = toHex(char1 & '\u000f');
                    bufferedWriter.write(new String(value));
                }
                else {
                    bufferedWriter.newLine();
                    if (char1 == '\r' && i != length - 1 && s.charAt(i + 1) == '\n') {
                        ++i;
                    }
                    if (i == length - 1 || (s.charAt(i + 1) != '#' && s.charAt(i + 1) != '!')) {
                        bufferedWriter.write("#");
                    }
                }
                n = i + 1;
            }
            ++i;
        }
        if (n != i) {
            bufferedWriter.write(s.substring(n, i));
        }
        bufferedWriter.newLine();
    }
    
    @Deprecated
    public void save(OutputStream outputStream, String s) {
        try {
            this.store(outputStream, s);
        }
        catch (IOException ex) {}
    }
    
    public void store(Writer out, String s) throws IOException {
        this.store0((out instanceof BufferedWriter) ? ((BufferedWriter)out) : new BufferedWriter(out), s, false);
    }
    
    public void store(OutputStream out, String s) throws IOException {
        this.store0(new BufferedWriter(new OutputStreamWriter(out, "8859_1")), s, true);
    }
    
    private void store0(BufferedWriter bufferedWriter, String s, boolean b) throws IOException {
        if (s != null) {
            writeComments(bufferedWriter, s);
        }
        bufferedWriter.write("#" + new Date().toString());
        bufferedWriter.newLine();
        synchronized (this) {
            Enumeration<Object> keys = this.keys();
            while (keys.hasMoreElements()) {
                String s2 = (String)keys.nextElement();
                bufferedWriter.write(this.saveConvert(s2, true, b) + "=" + this.saveConvert((String)this.get(s2), false, b));
                bufferedWriter.newLine();
            }
        }
        bufferedWriter.flush();
    }
    
    public synchronized void loadFromXML(InputStream inputStream) throws IOException, InvalidPropertiesFormatException {
        Properties.XmlSupport.load(this, (InputStream)Objects.requireNonNull(inputStream));
        inputStream.close();
    }
    
    public void storeToXML(OutputStream outputStream, String s) throws IOException {
        this.storeToXML(outputStream, s, "UTF-8");
    }
    
    public void storeToXML(OutputStream outputStream, String s, String s2) throws IOException {
        Properties.XmlSupport.save(this, (OutputStream)Objects.requireNonNull(outputStream), s, (String)Objects.requireNonNull(s2));
    }
    
    public String getProperty(String s) {
        Object value = super.get(s);
        String s2 = (value instanceof String) ? ((String)value) : null;
        return (s2 == null && this.defaults != null) ? this.defaults.getProperty(s) : s2;
    }
    
    public String getProperty(String s, String s2) {
        String property = this.getProperty(s);
        return (property == null) ? s2 : property;
    }
    
    public Enumeration<?> propertyNames() {
        Hashtable<String, Object> hashtable = new Hashtable();
        this.enumerate(hashtable);
        return hashtable.keys();
    }
    
    public Set<String> stringPropertyNames() {
        Hashtable<String, String> hashtable = new Hashtable();
        this.enumerateStringProperties(hashtable);
        return hashtable.keySet();
    }
    
    public void list(PrintStream printStream) {
        printStream.println("-- listing properties --");
        Hashtable<String, Object> hashtable = new Hashtable();
        this.enumerate(hashtable);
        Enumeration<Object> keys = hashtable.keys();
        while (keys.hasMoreElements()) {
            String str = (String)keys.nextElement();
            String string = (String)hashtable.get(str);
            if (string.length() > 40) {
                string = string.substring(0, 37) + "...";
            }
            printStream.println(str + "=" + string);
        }
    }
    
    public void list(PrintWriter printWriter) {
        printWriter.println("-- listing properties --");
        Hashtable<String, Object> hashtable = new Hashtable();
        this.enumerate(hashtable);
        Enumeration<Object> keys = hashtable.keys();
        while (keys.hasMoreElements()) {
            String str = (String)keys.nextElement();
            String string = (String)hashtable.get(str);
            if (string.length() > 40) {
                string = string.substring(0, 37) + "...";
            }
            printWriter.println(str + "=" + string);
        }
    }
    
    private synchronized void enumerate(Hashtable<String, Object> hashtable) {
        if (this.defaults != null) {
            this.defaults.enumerate(hashtable);
        }
        Enumeration<Object> keys = this.keys();
        while (keys.hasMoreElements()) {
            String s = (String)keys.nextElement();
            hashtable.put(s, this.get(s));
        }
    }
    
    private synchronized void enumerateStringProperties(Hashtable<String, String> hashtable) {
        if (this.defaults != null) {
            this.defaults.enumerateStringProperties(hashtable);
        }
        Enumeration<Object> keys = this.keys();
        while (keys.hasMoreElements()) {
            Object nextElement = keys.nextElement();
            Object value = this.get(nextElement);
            if (nextElement instanceof String && value instanceof String) {
                hashtable.put((String)nextElement, (String)value);
            }
            else {
                continue;
            }
        }
    }
    
    private static char toHex(int n) {
        return Properties.hexDigit[n & 0xF];
    }
    
    static {
        hexDigit = new char[] { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };
    }
    
    class LineReader
    {
        byte[] inByteBuf;
        char[] inCharBuf;
        char[] lineBuf;
        int inLimit;
        int inOff;
        InputStream inStream;
        Reader reader;
        
        public LineReader(InputStream inStream) {
            this.lineBuf = new char[1024];
            this.inLimit = 0;
            this.inOff = 0;
            this.inStream = inStream;
            this.inByteBuf = new byte[8192];
        }
        
        public LineReader(Reader reader) {
            this.lineBuf = new char[1024];
            this.inLimit = 0;
            this.inOff = 0;
            this.reader = reader;
            this.inCharBuf = new char[8192];
        }
        
        int readLine() throws IOException {
            int n = 0;
            int n2 = 1;
            int n3 = 0;
            int n4 = 1;
            int n5 = 0;
            int n6 = 0;
            int n7 = 0;
            while (true) {
                if (this.inOff >= this.inLimit) {
                    this.inLimit = ((this.inStream == null) ? this.reader.read(this.inCharBuf) : this.inStream.read(this.inByteBuf));
                    this.inOff = 0;
                    if (this.inLimit <= 0) {
                        if (n == 0 || n3 != 0) {
                            return -1;
                        }
                        if (n6 != 0) {
                            --n;
                        }
                        return n;
                    }
                }
                int n8;
                if (this.inStream != null) {
                    n8 = (char)(0xFF & this.inByteBuf[this.inOff++]);
                }
                else {
                    n8 = this.inCharBuf[this.inOff++];
                }
                if (n7 != 0) {
                    n7 = 0;
                    if (n8 == '\n') {
                        continue;
                    }
                }
                if (n2 != 0) {
                    if (n8 == ' ' || n8 == '\t') {
                        continue;
                    }
                    if (n8 == '\f') {
                        continue;
                    }
                    if (n5 == 0) {
                        if (n8 == '\r') {
                            continue;
                        }
                        if (n8 == '\n') {
                            continue;
                        }
                    }
                    n2 = 0;
                    n5 = 0;
                }
                if (n4 != 0) {
                    n4 = 0;
                    if (n8 == '#' || n8 == '!') {
                        n3 = 1;
                        continue;
                    }
                }
                if (n8 != '\n' && n8 != '\r') {
                    this.lineBuf[n++] = n8;
                    if (n == this.lineBuf.length) {
                        int n9 = this.lineBuf.length * 2;
                        if (n9 < 0) {
                            n9 = Integer.MAX_VALUE;
                        }
                        char[] lineBuf = new char[n9];
                        System.arraycopy(this.lineBuf, 0, lineBuf, 0, this.lineBuf.length);
                        this.lineBuf = lineBuf;
                    }
                    n6 = (n8 == '\\' && n6 == 0);
                }
                else if (n3 != 0 || n == 0) {
                    n3 = 0;
                    n4 = 1;
                    n2 = 1;
                    n = 0;
                }
                else {
                    if (this.inOff >= this.inLimit) {
                        this.inLimit = ((this.inStream == null) ? this.reader.read(this.inCharBuf) : this.inStream.read(this.inByteBuf));
                        this.inOff = 0;
                        if (this.inLimit <= 0) {
                            if (n6 != 0) {
                                --n;
                            }
                            return n;
                        }
                    }
                    if (n6 != 0) {
                        --n;
                        n2 = 1;
                        n5 = 1;
                        n6 = 0;
                        if (n8 != '\r') {
                            continue;
                        }
                        n7 = 1;
                    }
                    else {
                        return n;
                    }
                }
            }
        }
    }
    
    private static class XmlSupport
    {
        private static final XmlPropertiesProvider PROVIDER;
        
        private static XmlPropertiesProvider loadProviderFromProperty(ClassLoader loader) {
            String property = System.getProperty("sun.util.spi.XmlPropertiesProvider");
            if (property == null) {
                return null;
            }
            try {
                return (XmlPropertiesProvider)Class.forName(property, true, loader).newInstance();
            }
            catch (ClassNotFoundException | IllegalAccessException | InstantiationException ex) {
                throw new ServiceConfigurationError(null, ex);
            }
        }
        
        private static XmlPropertiesProvider loadProviderAsService(ClassLoader classLoader) {
            Iterator<XmlPropertiesProvider> iterator = ServiceLoader.load(XmlPropertiesProvider.class, classLoader).iterator();
            return iterator.hasNext() ? ((XmlPropertiesProvider)iterator.next()) : null;
        }
        
        private static XmlPropertiesProvider loadProvider() {
            return (XmlPropertiesProvider)AccessController.doPrivileged(new PrivilegedAction<XmlPropertiesProvider>() {
                @Override
                public XmlPropertiesProvider run() {
                    ClassLoader systemClassLoader = ClassLoader.getSystemClassLoader();
                    XmlPropertiesProvider access$000 = Properties.XmlSupport.access$000(systemClassLoader);
                    if (access$000 != null) {
                        return access$000;
                    }
                    XmlPropertiesProvider access$2 = Properties.XmlSupport.access$100(systemClassLoader);
                    if (access$2 != null) {
                        return access$2;
                    }
                    return new BasicXmlPropertiesProvider();
                }
            });
        }
        
        static void load(Properties properties, InputStream inputStream) throws IOException, InvalidPropertiesFormatException {
            Properties.XmlSupport.PROVIDER.load(properties, inputStream);
        }
        
        static void save(Properties properties, OutputStream outputStream, String s, String s2) throws IOException {
            Properties.XmlSupport.PROVIDER.store(properties, outputStream, s, s2);
        }
        
        static XmlPropertiesProvider access$000(ClassLoader classLoader) {
            return loadProviderFromProperty(classLoader);
        }
        
        static XmlPropertiesProvider access$100(ClassLoader classLoader) {
            return loadProviderAsService(classLoader);
        }
        
        static {
            PROVIDER = loadProvider();
        }
    }
}
